#include "eki_read.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_iki_read_eki_identify_alteration_
  void iki_read_eki_identify_alteration(iki_read_main_t * const main) {

    if (!main || !main->data || !(main->setting.replace.used || main->setting.wrap.used)) return;

    if (main->setting.flag & (iki_read_main_flag_content_d | iki_read_main_flag_literal_d)) {
      f_iki_eki_t * const data = (f_iki_eki_t *) main->data;

      f_number_unsigned_t i = 0;
      f_number_unsigned_t j = 0;
      f_number_unsigned_t k = 0;

      for (i = 0; i < data->vocabularys.used; ++i) {

        main->setting.map_replacess.array[i].used = 0;
        main->setting.map_wrapss.array[i].used = 0;

        for (j = 0; j < data->vocabularys.array[i].used; ++j) {

          if (iki_read_signal_check(main)) return;

          if (main->setting.replace.used) {
            k = main->setting.replace.used - 1;

            do {
              if (f_compare_dynamic_partial_string(main->setting.replace.array[k].key.string, main->cache.buffer, main->setting.replace.array[k].key.used, data->vocabularys.array[i].array[j]) == F_equal_to) {
                main->setting.state.status = f_memory_array_increase(main->setting.state.step_small, sizeof(f_number_unsigned_t), (void **) &main->setting.map_replacess.array[i].array, &main->setting.map_replacess.array[i].used, &main->setting.map_replacess.array[i].size);

                if (F_status_is_error(main->setting.state.status)) {
                  iki_read_print_error(&main->program.error, macro_iki_read_f(f_memory_array_increase));

                  return;
                }

                main->setting.map_replacess.array[i].array[main->setting.map_replacess.array[i].used++] = k;
              }

            } while (k--);
          }

          if (main->setting.wrap.used) {
            k = main->setting.wrap.used - 1;

            do {
              if (f_compare_dynamic_partial_string(main->setting.wrap.array[k].a.string, main->cache.buffer, main->setting.wrap.array[k].a.used, data->vocabularys.array[i].array[j]) == F_equal_to) {
                main->setting.state.status = f_memory_array_increase(main->setting.state.step_small, sizeof(f_number_unsigned_t), (void **) &main->setting.map_wrapss.array[i].array, &main->setting.map_wrapss.array[i].used, &main->setting.map_wrapss.array[i].size);

                if (F_status_is_error(main->setting.state.status)) {
                  iki_read_print_error(&main->program.error, macro_iki_read_f(f_memory_array_increase));

                  return;
                }

                main->setting.map_wrapss.array[i].array[main->setting.map_wrapss.array[i].used++] = k;
              }

            } while (k--);
          }
        } // for
      } // for
    }
  }
#endif // _di_iki_read_eki_identify_alteration_

#ifdef __cplusplus
} // extern "C"
#endif
