#include "eki_read.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_iki_read_iki_process_buffer_at_
  void iki_read_eki_process_buffer_at(iki_read_main_t * const main, const f_number_unsigned_t index) {

    if (!main || F_status_is_error(main->setting.state.status)) return;

    // @todo replace all of this with what is in iki_read_eki_print_data() once that is updated/fixed appropriately.

    if (!main->data) {
      main->setting.state.status = F_status_set_error(F_parameter);
    }
    else {
      f_iki_eki_t * const data = (f_iki_eki_t *) main->data;

      if (index >= data->vocabularys.used) {
        main->setting.state.status = F_data_not;

        return;
      }

      f_number_unsigned_t i = main->setting.reassign.used;
      f_number_unsigned_t j = 0;
      f_range_t range = f_range_t_initialize;

      // @todo this needs to handle all j where .array[0].
      if (main->setting.reassign.used && (main->setting.flag & (iki_read_main_flag_content_d | iki_read_main_flag_literal_d))) {
        i = iki_read_identify_substitution(main, data->vocabularys.array[index].array[0], data->content.array[index], &main->setting.reassign);
      }

      if (i < main->setting.reassign.used) {
        if (main->setting.flag & iki_read_main_flag_content_d) {
          main->setting.state.status = f_string_dynamic_append_nulless(main->setting.reassign.array[i].c, &main->cache.expand);
        }
        else {
          range.start = data->variable.array[index].start;
          range.stop = data->content.array[index].start - 1;

          main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, range, &main->cache.expand);

          if (F_status_is_error_not(main->setting.state.status)) {
            main->setting.state.status = f_string_dynamic_append_nulless(main->setting.reassign.array[i].c, &main->cache.expand);
          }

          if (F_status_is_error_not(main->setting.state.status)) {
            range.start = data->content.array[index].stop + 1;
            range.stop = data->variable.array[index].stop;

            main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, range, &main->cache.expand);
          }
        }
      }
      else {
        i = main->setting.substitute.used;

        if (main->setting.substitute.used && (main->setting.flag & (iki_read_main_flag_content_d | iki_read_main_flag_literal_d))) {
          i = iki_read_identify_substitution(main, data->vocabularys.array[index].array[0], data->content.array[index], &main->setting.substitute);
        }

        if (i < main->setting.substitute.used) {
          if (main->setting.flag & iki_read_main_flag_content_d) {
            iki_read_process_wrap_prepend(main, index);

            if (F_status_is_error_not(main->setting.state.status)) {
              main->setting.state.status = f_string_dynamic_append_nulless(main->setting.substitute.array[i].c, &main->cache.expand);
            }

            iki_read_process_wrap_append(main, index);
          }
          else {
            range.start = data->variable.array[index].start;
            range.stop = data->content.array[index].start - 1;

            main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, range, &main->cache.expand);

            iki_read_process_wrap_prepend(main, index);

            if (F_status_is_error_not(main->setting.state.status)) {
              main->setting.state.status = f_string_dynamic_append_nulless(main->setting.substitute.array[i].c, &main->cache.expand);
            }

            iki_read_process_wrap_append(main, index);

            if (F_status_is_error_not(main->setting.state.status)) {
              range.start = data->content.array[index].stop + 1;
              range.stop = data->variable.array[index].stop;

              main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, range, &main->cache.expand);
            }
          }
        }
        else if (main->setting.replace.used && main->setting.map_replacess.array[index].used) {
          if (main->setting.flag & iki_read_main_flag_content_d) {
            iki_read_process_wrap_prepend(main, index);

            for (i = 0; F_status_is_error_not(main->setting.state.status) && i < main->setting.map_replacess.array[index].used; ++i) {

              if (main->setting.map_replacess.array[index].array[i] < main->setting.replace.used) {
                main->setting.state.status = f_string_dynamic_append_nulless(main->setting.replace.array[main->setting.map_replacess.array[index].array[i]].value, &main->cache.expand);
              }
            } // for

            iki_read_process_wrap_append(main, index);
          }
          else if (main->setting.flag & iki_read_main_flag_object_d) {
            if (main->setting.flag & iki_read_main_flag_select_d) {
              if (main->setting.select < main->setting.map_replacess.array[index].used) {
                main->setting.state.status = f_string_dynamic_append_nulless(main->setting.replace.array[main->setting.map_replacess.array[index].array[main->setting.select]].key, &main->cache.expand);
              }
            }
            else {
              for (i = 0; F_status_is_error_not(main->setting.state.status) && i < main->setting.map_replacess.array[index].used; ++i) {

                if (main->setting.map_replacess.array[index].array[i] < main->setting.replace.used) {
                  main->setting.state.status = f_string_dynamic_append_nulless(main->setting.replace.array[main->setting.map_replacess.array[index].array[i]].key, &main->cache.expand);
                }
              } // for
            }
          }
          else {
            range.start = data->variable.array[index].start;
            range.stop = data->content.array[index].start - 1;

            main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, range, &main->cache.expand);

            iki_read_process_wrap_prepend(main, index);

            for (i = 0; F_status_is_error_not(main->setting.state.status) && i < main->setting.map_replacess.array[index].used; ++i) {

              if (main->setting.map_replacess.array[index].array[i] < main->setting.replace.used) {
                main->setting.state.status = f_string_dynamic_append_nulless(main->setting.replace.array[main->setting.map_replacess.array[index].array[i]].value, &main->cache.expand);
              }
            } // for


            iki_read_process_wrap_append(main, index);

            if (F_status_is_error_not(main->setting.state.status)) {
              range.start = data->content.array[index].stop + 1;
              range.stop = data->variable.array[index].stop;

              main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, range, &main->cache.expand);
            }
          }
        }
        else if (main->setting.flag & iki_read_main_flag_content_d) {
          iki_read_process_wrap_prepend(main, index);

          if (F_status_is_error_not(main->setting.state.status)) {
            main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, data->content.array[index], &main->cache.expand);
          }

          iki_read_process_wrap_append(main, index);
        }
        else if (main->setting.flag & iki_read_main_flag_object_d) {
          if (main->setting.flag & iki_read_main_flag_select_d) {
            if (main->setting.select < data->vocabularys.array[index].used) {
              main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, data->vocabularys.array[index].array[main->setting.select], &main->cache.expand);
            }
          }
          else {
            for (i = 0; F_status_is_error_not(main->setting.state.status) && i < data->vocabularys.array[index].used; ) {

              main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, data->vocabularys.array[index].array[i], &main->cache.expand);

              if (F_status_is_error_not(main->setting.state.status)) {
                if (++i < data->vocabularys.array[index].used) {
                  main->setting.state.status = f_string_dynamic_append_nulless(f_string_space_s, &main->cache.expand);
                }
              }
            } // for
          }
        }
        else {
          range.start = data->variable.array[index].start;
          range.stop = data->content.array[index].start - 1;

          main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, range, &main->cache.expand);

          iki_read_process_wrap_prepend(main, index);

          if (F_status_is_error_not(main->setting.state.status)) {
            main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, data->content.array[index], &main->cache.expand);
          }

          iki_read_process_wrap_append(main, index);

          if (F_status_is_error_not(main->setting.state.status)) {
            range.start = data->content.array[index].stop + 1;
            range.stop = data->variable.array[index].stop;

            main->setting.state.status = f_string_dynamic_partial_append_nulless(main->cache.buffer, range, &main->cache.expand);
          }
        }
      }
    }

    if (F_status_is_error(main->setting.state.status)) {
      iki_read_print_error(&main->program.error, macro_iki_read_f(iki_read_callback_process_buffer_line));

      return;
    }

    main->setting.state.status = main->cache.expand.used ? F_okay : F_data_not;
  }
#endif // _di_iki_read_iki_process_buffer_at_

#ifndef _di_iki_read_eki_process_buffer_ranges_
  void iki_read_eki_process_buffer_ranges(iki_read_main_t * const main, f_range_t * const range_buffer) {

    if (!main || !main->data || !range_buffer) return;

    f_iki_eki_t * const data = (f_iki_eki_t *) main->data;

    iki_read_eki_process_buffer_ranges_prepare(main, range_buffer, data);
    if (F_status_is_error(main->setting.state.status)) return;

    // When --at and --line are specified, the only value for --line that will print anything is 0 when using --object.
    if ((main->setting.flag & iki_read_main_flag_at_d) && (main->setting.flag & iki_read_main_flag_line_d)) {
      if ((main->setting.flag & iki_read_main_flag_object_d) && main->setting.line) {
        if (main->setting.flag & iki_read_main_flag_total_d) {
          iki_read_print_data_total(&main->program.output, 0);
        }

        main->setting.state.status = F_data_not;

        return;
      }
    }

    main->cache.expand.used = 0;

    f_number_unsigned_t i = 0;
    f_number_unsigned_t j = 0;

    if (main->setting.flag & iki_read_main_flag_name_d) {
      f_number_unsigned_t k = 0;
      f_number_unsigned_t matches = 0;
      uint8_t matched = 0x0; // 0x0 = unmatched, 0x1 = matched.

      for (i = 0; i < data->vocabularys.used; ++i) {

        if (iki_read_signal_check(main)) return;

        for (j = 0; j < data->vocabularys.array[i].used; ++j) {

          if (iki_read_signal_check(main)) return;

          for (k = 0; k < main->setting.names.used; ++k) {

            if (iki_read_signal_check(main)) return;

            if (f_compare_dynamic_partial_string(main->setting.names.array[k].string, main->cache.buffer, main->setting.names.array[k].used, data->vocabularys.array[i].array[j]) == F_equal_to) {
              matched |= 0x1;

              if (main->setting.flag & iki_read_main_flag_at_d) {
                if (matches < main->setting.at) {
                  matches++;

                  continue;
                }

                if (matches++ > main->setting.at) break;
              }

              if (main->setting.flag & iki_read_main_flag_total_d) {
                if (!(main->setting.flag & iki_read_main_flag_at_d)) {
                  ++matches;
                }

                if (main->setting.flag & (iki_read_main_flag_at_d | iki_read_main_flag_line_d)) {
                  iki_read_eki_process_buffer_at(main, i);
                  iki_read_process_buffer_at_newline(main);
                }
              }
              else if (main->setting.flag & iki_read_main_flag_line_d) {
                iki_read_eki_process_buffer_at(main, i);
                iki_read_process_buffer_at_newline(main);
              }
              else {
                f_file_stream_lock(main->program.output.to);

                if (main->callback.print_data) {
                  main->callback.print_data(&main->program.output, i);
                }

                f_print_dynamic_raw(f_string_eol_s, main->program.output.to);

                f_file_stream_unlock(main->program.output.to);
              }
            }
          } // for
        } // for
      } // for

      if (main->setting.flag & iki_read_main_flag_line_d) {
        if (main->setting.flag & iki_read_main_flag_total_d) {
          iki_read_print_data_total_expand(&main->program.output);
        }
        else {
          iki_read_print_data_line(&main->program.output);
        }
      }
      else if (main->setting.flag & iki_read_main_flag_total_d) {
        if (main->setting.flag & iki_read_main_flag_at_d) {
          iki_read_print_data_total_expand(&main->program.output);
        }
        else {
          iki_read_print_data_total(&main->program.output, matches);
        }

        main->setting.state.status = matched ? F_okay : F_data_not;

        return;
      }
      else {
        f_file_stream_unlock(main->program.output.to);
      }

      main->setting.state.status = matched ? F_okay : F_data_not;
    }
    else {
      if (data->variable.used) {
        if (main->setting.flag & iki_read_main_flag_at_d) {
          if (main->setting.at < data->variable.used) {
            if (main->setting.flag & iki_read_main_flag_line_d) {
              iki_read_eki_process_buffer_at(main, main->setting.at);
              iki_read_process_buffer_at_newline(main);

              if (main->setting.flag & iki_read_main_flag_total_d) {
                iki_read_print_data_total_expand(&main->program.output);
              }
              else {
                iki_read_print_data_line(&main->program.output);
              }
            }
            else if (main->setting.flag & iki_read_main_flag_total_d) {
              if (main->setting.flag & iki_read_main_flag_object_d) {
                iki_read_print_data_total(&main->program.output, ((main->setting.flag & iki_read_main_flag_select_d) && main->setting.select) ? 0 : 1);
              }
              else {
                iki_read_eki_process_buffer_at(main, main->setting.at);
                iki_read_process_buffer_at_newline(main);

                iki_read_print_data_total_expand(&main->program.output);
              }
            }
            else {
              f_file_stream_lock(main->program.output.to);

              if (main->callback.print_data) {
                main->callback.print_data(&main->program.output, main->setting.at);
              }

              f_print_dynamic_raw(f_string_eol_s, main->program.output.to);

              f_file_stream_unlock(main->program.output.to);

              main->setting.state.status = F_okay;
            }

            if (F_status_is_error_not(main->setting.state.status)) {
              main->setting.state.status = F_okay;
            }
          }
          else {
            if (main->setting.flag & iki_read_main_flag_total_d) {
              iki_read_print_data_total(&main->program.output, 0);
            }

            main->setting.state.status = F_data_not;
          }
        }
        else if (main->setting.flag & iki_read_main_flag_line_d) {
          for (i = 0; F_status_is_error_not(main->setting.state.status) && i < data->variable.used; ++i) {

            if (iki_read_signal_check(main)) return;

            iki_read_eki_process_buffer_at(main, i);
            iki_read_process_buffer_at_newline(main);
          } // for

          if (main->setting.flag & iki_read_main_flag_total_d) {
            iki_read_print_data_total_expand(&main->program.output);
          }
          else {
            iki_read_print_data_line(&main->program.output);
          }
        }
        else if (main->setting.flag & iki_read_main_flag_total_d) {
          if (main->setting.flag & iki_read_main_flag_object_d) {
            iki_read_print_data_total(&main->program.output, ((main->setting.flag & iki_read_main_flag_select_d) && main->setting.select) ? 0 : data->variable.used);
          }
          else {
            for (i = 0; F_status_is_error_not(main->setting.state.status) && i < data->variable.used; ++i) {

              if (iki_read_signal_check(main)) return;

              iki_read_eki_process_buffer_at(main, i);
              iki_read_process_buffer_at_newline(main);
            } // for

            iki_read_print_data_total_expand(&main->program.output);
          }
        }
        else {
          f_file_stream_lock(main->program.output.to);

          for (i = 0; i < data->variable.used; ++i) {

            if (iki_read_signal_check(main)) return;

            if (main->callback.print_data) {
              main->callback.print_data(&main->program.output, i);
            }

            f_print_dynamic_raw(f_string_eol_s, main->program.output.to);
          } // for

          f_file_stream_unlock(main->program.output.to);

          main->setting.state.status = i < data->variable.used ? F_data_not : F_okay;
        }
      }
      else {
        if (main->setting.flag & iki_read_main_flag_total_d) {
          iki_read_print_data_total(&main->program.output, 0);
        }

        main->setting.state.status = F_data_not;
      }
    }
  }
#endif // _di_iki_read_eki_process_buffer_ranges_

#ifndef _di_iki_read_eki_process_buffer_ranges_prepare_
  void iki_read_eki_process_buffer_ranges_prepare(iki_read_main_t * const main, f_range_t * const range_buffer, f_iki_eki_t * const data) {

    if (!main || !range_buffer || !data) return;

    fl_iki_eki_read(&main->cache.buffer, range_buffer, data, &main->setting.state);

    if (F_status_is_error(main->setting.state.status)) {
      iki_read_print_error(&main->program.error, macro_iki_read_f(fl_iki_read));

      return;
    }

    f_number_unsigned_t i = 0;

    for (; i < main->setting.map_replacess.used; ++i) {
      main->setting.map_replacess.array[i].used = 0;
    } // for

    for (i = 0; i < main->setting.map_wrapss.used; ++i) {
      main->setting.map_wrapss.array[i].used = 0;
    } // for

    main->setting.map_replacess.used = 0;
    main->setting.map_wrapss.used = 0;

    main->setting.state.status = f_memory_arrays_resize(data->vocabularys.used, sizeof(f_number_unsigneds_t), (void **) &main->setting.map_replacess.array, &main->setting.map_replacess.used, &main->setting.map_replacess.size, &f_number_unsignedss_delete_callback);

    if (F_status_is_error_not(main->setting.state.status)) {
      main->setting.state.status = f_memory_arrays_resize(data->vocabularys.used, sizeof(f_number_unsigneds_t), (void **) &main->setting.map_wrapss.array, &main->setting.map_wrapss.used, &main->setting.map_wrapss.size, &f_number_unsignedss_delete_callback);
    }

    if (F_status_is_error(main->setting.state.status)) {
      iki_read_print_error(&main->program.error, macro_iki_read_f(f_memory_arrays_resize));

      return;
    }

    main->setting.map_wrapss.used = main->setting.map_replacess.used = data->vocabularys.used;

    for (i = 0; i < data->delimits.used; ++i) {
      main->cache.buffer.string[data->delimits.array[i]] = f_iki_syntax_placeholder_s.string[0];
    } // for

    if (main->callback.identify_alteration) {
      main->callback.identify_alteration(main);
    }
  }
#endif // _di_iki_read_eki_process_buffer_ranges_prepare_

#ifndef _di_iki_read_eki_process_buffer_ranges_whole_
  void iki_read_eki_process_buffer_ranges_whole(iki_read_main_t * const main, f_range_t * const range_buffer) {

    if (!main || !main->data || !range_buffer) return;

    f_iki_eki_t * const data = (f_iki_eki_t *) main->data;

    const f_range_t range_original = *range_buffer;

    iki_read_eki_process_buffer_ranges_prepare(main, range_buffer, data);
    if (F_status_is_error(main->setting.state.status)) return;

    if (!data->variable.used) {
      fll_print_dynamic_partial(main->cache.buffer, range_original, main->program.output.to);

      main->setting.state.status = F_okay;

      return;
    }

    f_number_unsigned_t i = 0;
    f_number_unsigned_t j = 0;
    f_number_unsigned_t k = 0;
    f_number_unsigned_t l = 0;
    f_number_unsigned_t at = 0;
    f_number_unsigned_t stop = data->variable.used;

    i = range_original.start;
    *range_buffer = range_original;

    f_file_stream_lock(main->program.output.to);

    while (i <= range_buffer->stop && j < stop) {

      if (iki_read_signal_check(main)) return;

      if (i < data->variable.array[j].start) {
        range_buffer->start = i;
        range_buffer->stop = data->variable.array[j].start - 1;

        f_print_dynamic_partial(main->cache.buffer, *range_buffer, main->program.output.to);

        range_buffer->start = data->variable.array[j].stop + 1;
        range_buffer->stop = range_original.stop;

        i = data->variable.array[j].start;
      }

      if (main->setting.names.used) {
        for (k = 0; k < main->setting.names.used; ++k) {

          for (l = 0; l < data->vocabularys.array[j].used; ++l) {
            if (f_compare_dynamic_partial_string(main->setting.names.array[k].string, main->cache.buffer, main->setting.names.array[k].used, data->vocabularys.array[j].array[l]) == F_equal_to) break;
          }

          if (l < data->vocabularys.array[j].used) break;
        } // for

        if (k < main->setting.names.used) {
          if (main->setting.flag & iki_read_main_flag_at_d) {
            if (at++ == main->setting.at) {
              if (main->callback.print_data) {
                main->callback.print_data(&main->program.output, j);
              }
            }
            else {
              f_print_dynamic_partial(main->cache.buffer, data->variable.array[j], main->program.output.to);
            }
          }
          else if (main->callback.print_data) {
            main->callback.print_data(&main->program.output, j);
          }
        }
        else {

          // Unmatched names are printed as-is (the entire variable).
          f_print_dynamic_partial(main->cache.buffer, data->variable.array[j], main->program.output.to);
        }
      }
      else if (main->setting.flag & iki_read_main_flag_at_d) {
        if (at++ == main->setting.at) {
          if (main->callback.print_data) {
            main->callback.print_data(&main->program.output, j);
          }
        }
        else {
          f_print_dynamic_partial(main->cache.buffer, data->variable.array[j], main->program.output.to);
        }
      }
      else {
        if (main->callback.print_data) {
          main->callback.print_data(&main->program.output, j);
        }
      }

      i = data->variable.array[j].stop + 1;
      ++j;
    } // while

    if (i <= range_original.stop) {
      range_buffer->start = i;
      f_print_dynamic_partial(main->cache.buffer, *range_buffer, main->program.output.to);
    }

    f_file_stream_unlock(main->program.output.to);

    main->setting.state.status = F_okay;
  }
#endif // _di_iki_read_eki_process_buffer_ranges_whole_

#ifndef _di_iki_read_eki_process_buffer_total_
  void iki_read_eki_process_buffer_total(iki_read_main_t * const main) {

    if (!main || !main->data) return;

    f_number_unsigned_t total = 0;
    f_number_unsigned_t i = 0;

    if ((main->setting.flag & iki_read_main_flag_whole_d) && !(main->setting.flag & iki_read_main_flag_line_d)) {
      for (; i < main->cache.buffer.used; ++i) {
        if (main->cache.buffer.string[i] == f_string_eol_s.string[0]) ++total;
      } // for
    }
    else {
      f_iki_eki_t * const data = (f_iki_eki_t *) main->data;

      f_range_t range = macro_f_range_t_initialize_2(main->cache.buffer.used);

      iki_read_process_line(main, &range);

      if (main->setting.state.status == F_true || main->setting.state.status == F_data_not) {
        if (main->setting.state.status == F_data_not || range.start > main->cache.buffer.used) {
          fll_print_format("%r%r", main->program.output.to, f_string_ascii_0_s, f_string_eol_s);

          main->setting.state.status = F_okay;

          return;
        }
      }

      fl_iki_eki_read(&main->cache.buffer, &range, data, &main->setting.state);

      if (F_status_is_error(main->setting.state.status)) {
        iki_read_print_error(&main->program.error, macro_iki_read_f(fl_iki_eki_read));

        return;
      }

      if (!(main->setting.flag & iki_read_main_flag_name_d)) {
        total = (main->setting.flag & iki_read_main_flag_at_d)
          ? main->setting.at < data->vocabularys.used ? 1 : 0
          : data->vocabularys.used;
      }
      else {
        for (; i < data->delimits.used; ++i) {
          main->cache.buffer.string[data->delimits.array[i]] = f_iki_syntax_placeholder_s.string[0];
        } // for

        if (main->program.parameters.array[iki_read_parameter_name_e].result & f_console_result_value_e) {
          f_string_dynamic_t name = f_string_dynamic_t_initialize;

          f_number_unsigned_t index = 0;
          f_number_unsigned_t j = 0;
          f_number_unsigned_t k = 0;

          range.start = 0;

          for (i = 0; i < main->program.parameters.array[iki_read_parameter_name_e].values.used; ++i) {

            if (iki_read_signal_check(main)) return;

            index = main->program.parameters.array[iki_read_parameter_name_e].values.array[i];
            name.used = 0;

            main->setting.state.status = f_string_dynamic_append_nulless(main->program.parameters.arguments.array[index], &name);

            if (F_status_is_error(main->setting.state.status)) {
              iki_read_print_error(&main->program.error, macro_iki_read_f(f_string_dynamic_append_nulless));

              f_memory_array_resize(0, sizeof(f_char_t), (void **) &name.string, &name.used, &name.size);

              return;
            }

            range.stop = name.used - 1;

            for (j = 0; j < data->vocabularys.used; ++j) {

              if (iki_read_signal_check(main)) return;

              for (k = 0; k < data->vocabularys.array[j].used; ++k) {

                if (iki_read_signal_check(main)) return;

                main->setting.state.status = f_compare_dynamic_partial(name, main->cache.buffer, range, data->vocabularys.array[j].array[k]);

                if (main->setting.state.status == F_equal_to) ++total;
              } // for
            } // for
          } // for

          f_memory_array_resize(0, sizeof(f_char_t), (void **) &name.string, &name.used, &name.size);
        }
        else {
          total = data->variable.used;
        }

        // If the "at" position is within the actual total, then the total at the given position is 1, otherwise is 0.
        if (main->setting.flag & iki_read_main_flag_at_d) {
          total = main->setting.at < total ? 1 : 0;
        }
      }
    }

    iki_read_print_data_total(&main->program.output, total);

    main->setting.state.status = F_okay;
  }
#endif // _di_iki_read_eki_process_buffer_total_

#ifdef __cplusplus
} // extern "C"
#endif
