#include "iki_read.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_iki_read_iki_identify_alteration_
  void iki_read_iki_identify_alteration(iki_read_main_t * const main) {

    if (!main || !main->data || !(main->setting.replace.used || main->setting.wrap.used)) return;
    if (!(main->setting.flag & (iki_read_main_flag_content_d | iki_read_main_flag_literal_d))) return;

    f_iki_data_t * const data = (f_iki_data_t *) main->data;

    f_number_unsigned_t i = 0;
    f_number_unsigned_t j = 0;

    for (i = 0; i < data->vocabulary.used; ++i) {

      if (iki_read_signal_check(main)) return;

      if (main->setting.replace.used) {
        main->setting.map_replacess.array[i].used = 0;

        j = main->setting.replace.used - 1;

        do {
          if (f_compare_dynamic_partial_string(main->setting.replace.array[j].key.string, main->cache.buffer, main->setting.replace.array[j].key.used, data->vocabulary.array[i]) == F_equal_to) {
            main->setting.map_replacess.array[i].used = 0;

            main->setting.state.status = f_memory_array_increase_by(1, sizeof(f_number_unsigned_t), (void **) &main->setting.map_replacess.array[i].array, &main->setting.map_replacess.array[i].used, &main->setting.map_replacess.array[i].size);

            if (F_status_is_error(main->setting.state.status)) {
              iki_read_print_error(&main->program.error, macro_iki_read_f(f_memory_array_increase_by));

              return;
            }

            main->setting.map_replacess.array[i].array[main->setting.map_replacess.array[i].used++] = j;

            break;
          }

        } while (j--);
      }

      if (main->setting.wrap.used) {
        main->setting.map_wrapss.array[i].used = 0;

        j = main->setting.wrap.used - 1;

        do {
          if (f_compare_dynamic_partial_string(main->setting.wrap.array[j].a.string, main->cache.buffer, main->setting.wrap.array[j].a.used, data->vocabulary.array[i]) == F_equal_to) {
            main->setting.map_wrapss.array[i].used = 0;

            main->setting.state.status = f_memory_array_increase_by(1, sizeof(f_number_unsigned_t), (void **) &main->setting.map_wrapss.array[i].array, &main->setting.map_wrapss.array[i].used, &main->setting.map_wrapss.array[i].size);

            if (F_status_is_error(main->setting.state.status)) {
              iki_read_print_error(&main->program.error, macro_iki_read_f(f_memory_array_increase_by));

              return;
            }

            main->setting.map_wrapss.array[i].array[main->setting.map_wrapss.array[i].used++] = j;

            break;
          }

        } while (j--);
      }
    } // for
  }
#endif // _di_iki_read_iki_identify_alteration_

#ifdef __cplusplus
} // extern "C"
#endif
