#include "iki_read.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_iki_read_iki_print_data_
  void iki_read_iki_print_data(fl_print_t * const print, const f_number_unsigned_t index) {

    if (!print || !print->custom) return;

    iki_read_main_t * const main = (iki_read_main_t *) print->custom;

    if (!main->data) return;

    f_iki_data_t * const data = (f_iki_data_t *) main->data;

    if (index >= data->vocabulary.used) return;

    f_number_unsigned_t i = main->setting.reassign.used;
    f_range_t range = f_range_t_initialize;

    if (main->setting.reassign.used && (main->setting.flag & (iki_read_main_flag_content_d | iki_read_main_flag_literal_d))) {
      i = iki_read_identify_substitution(main, data->vocabulary.array[index], data->content.array[index], &main->setting.reassign);
    }

    if (i < main->setting.reassign.used) {
      if (main->setting.flag & iki_read_main_flag_content_d) {
        f_print_dynamic(main->setting.reassign.array[i].c, main->program.output.to);
      }
      else {
        range.start = data->variable.array[index].start;
        range.stop = data->content.array[index].start - 1;

        f_print_dynamic_partial(main->cache.buffer, range, main->program.output.to);

        f_print_dynamic(main->setting.reassign.array[i].c, main->program.output.to);

        range.start = data->content.array[index].stop + 1;
        range.stop = data->variable.array[index].stop;

        f_print_dynamic_partial(main->cache.buffer, range, main->program.output.to);
      }

      return;
    }

    i = main->setting.substitute.used;

    if (main->setting.substitute.used && (main->setting.flag & (iki_read_main_flag_content_d | iki_read_main_flag_literal_d))) {
      i = iki_read_identify_substitution(main, data->vocabulary.array[index], data->content.array[index], &main->setting.substitute);
    }

    if (i < main->setting.substitute.used) {
      if (main->setting.flag & iki_read_main_flag_content_d) {
        iki_read_print_data_wrap_prepend(&main->program.output, index);

        f_print_dynamic(main->setting.substitute.array[i].c, main->program.output.to);

        iki_read_print_data_wrap_append(&main->program.output, index);
      }
      else {
        range.start = data->variable.array[index].start;
        range.stop = data->content.array[index].start - 1;

        f_print_dynamic_partial(main->cache.buffer, range, main->program.output.to);

        iki_read_print_data_wrap_prepend(&main->program.output, index);

        f_print_dynamic(main->setting.substitute.array[i].c, main->program.output.to);

        iki_read_print_data_wrap_append(&main->program.output, index);

        range.start = data->content.array[index].stop + 1;
        range.stop = data->variable.array[index].stop;

        f_print_dynamic_partial(main->cache.buffer, range, main->program.output.to);
      }
    }
    else if (main->setting.replace.used && main->setting.map_replacess.array[index].used) {
      if (main->setting.flag & iki_read_main_flag_content_d) {
        iki_read_print_data_wrap_prepend(&main->program.output, index);

        if (main->setting.map_replacess.array[index].array[0] < main->setting.replace.used) {
          f_print_dynamic(main->setting.replace.array[main->setting.map_replacess.array[index].array[0]].value, main->program.output.to);
        }

        iki_read_print_data_wrap_append(&main->program.output, index);
      }
      else if (main->setting.flag & iki_read_main_flag_object_d) {
        if (!(main->setting.flag & iki_read_main_flag_select_d) || !main->setting.select) {
          if (main->setting.map_replacess.array[index].array[0] < main->setting.replace.used) {
            f_print_dynamic(main->setting.replace.array[main->setting.map_replacess.array[index].array[0]].key, main->program.output.to);
          }
        }
      }
      else {
        range.start = data->variable.array[index].start;
        range.stop = data->content.array[index].start - 1;

        f_print_dynamic_partial(main->cache.buffer, range, main->program.output.to);

        iki_read_print_data_wrap_prepend(&main->program.output, index);

        if (main->setting.map_replacess.array[index].array[0] < main->setting.replace.used) {
          f_print_dynamic(main->setting.replace.array[main->setting.map_replacess.array[index].array[0]].value, main->program.output.to);
        }

        iki_read_print_data_wrap_append(&main->program.output, index);

        range.start = data->content.array[index].stop + 1;
        range.stop = data->variable.array[index].stop;

        f_print_dynamic_partial(main->cache.buffer, range, main->program.output.to);
      }
    }
    else if (main->setting.flag & iki_read_main_flag_content_d) {
      iki_read_print_data_wrap_prepend(&main->program.output, index);

      f_print_dynamic_partial(main->cache.buffer, data->content.array[index], main->program.output.to);

      iki_read_print_data_wrap_append(&main->program.output, index);
    }
    else if (main->setting.flag & iki_read_main_flag_object_d) {
      if (!(main->setting.flag & iki_read_main_flag_select_d) || !main->setting.select) {
        f_print_dynamic_partial(main->cache.buffer, data->vocabulary.array[index], main->program.output.to);
      }
      else if ((main->setting.flag & iki_read_main_flag_select_d) && main->setting.select) {
        main->setting.state.status = F_data_not;
      }
    }
    else {
      range.start = data->variable.array[index].start;
      range.stop = data->content.array[index].start - 1;

      f_print_dynamic_partial(main->cache.buffer, range, main->program.output.to);

      iki_read_print_data_wrap_prepend(&main->program.output, index);

      f_print_dynamic_partial(main->cache.buffer, data->content.array[index], main->program.output.to);

      iki_read_print_data_wrap_append(&main->program.output, index);

      range.start = data->content.array[index].stop + 1;
      range.stop = data->variable.array[index].stop;

      f_print_dynamic_partial(main->cache.buffer, range, main->program.output.to);
    }
  }
#endif // _di_iki_read_iki_print_data_

#ifndef _di_iki_read_iki_print_message_help_
  void iki_read_iki_print_message_help(fl_print_t * const print) {

    if (!print) return;

    f_file_stream_lock(print->to);

    fll_program_print_help_header(print, iki_read_program_name_long_s, iki_read_program_version_s);

    iki_read_print_message_help(print);

    f_print_dynamic_raw(f_string_eol_s, print->to);

    fll_program_print_help_usage(print, iki_read_program_name_s, f_string_empty_s);

    iki_read_print_message_help_note(print);

    f_file_stream_flush(print->to);
    f_file_stream_unlock(print->to);
  }
#endif // _di_iki_read_iki_print_message_help_

#ifdef __cplusplus
} // extern "C"
#endif
