#include "../iki_read.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_iki_read_setting_delete_
  void iki_read_cache_delete(iki_read_cache_t * const cache) {

    if (!cache) return;

    f_memory_array_resize(0, sizeof(f_char_t), (void **) &cache->buffer.string, &cache->buffer.used, &cache->buffer.size);
    f_memory_array_resize(0, sizeof(f_char_t), (void **) &cache->expand.string, &cache->expand.used, &cache->expand.size);
  }
#endif // _di_iki_read_cache_delete_

#ifndef _di_iki_read_main_delete_
  void iki_read_main_delete(iki_read_main_t * const main) {

    if (!main) return;

    iki_read_cache_delete(&main->cache);
    fll_program_data_delete(&main->program);
    iki_read_setting_delete(&main->setting);

    if (main->callback.delete_data) {
      main->callback.delete_data(main);
    }
  }
#endif // _di_iki_read_main_delete_

#ifndef _di_iki_read_setting_delete_
  void iki_read_setting_delete(iki_read_setting_t * const setting) {

    if (!setting) return;

    f_memory_arrays_resize(0, sizeof(f_string_dynamic_t), (void **) &setting->names.array, &setting->names.used, &setting->names.size, &f_string_dynamics_delete_callback);
    f_memory_arrays_resize(0, sizeof(f_string_dynamic_t), (void **) &setting->files.array, &setting->files.used, &setting->files.size, &f_string_dynamics_delete_callback);

    f_memory_arrays_resize(0, sizeof(f_string_map_t), (void **) &setting->replace.array, &setting->replace.used, &setting->replace.size, &f_string_maps_delete_callback);

    f_memory_arrays_resize(0, sizeof(f_string_triple_t), (void **) &setting->reassign.array, &setting->reassign.used, &setting->reassign.size, &f_string_triples_delete_callback);
    f_memory_arrays_resize(0, sizeof(f_string_triple_t), (void **) &setting->substitute.array, &setting->substitute.used, &setting->substitute.size, &f_string_triples_delete_callback);
    f_memory_arrays_resize(0, sizeof(f_string_triple_t), (void **) &setting->wrap.array, &setting->wrap.used, &setting->wrap.size, &f_string_triples_delete_callback);

    f_memory_arrays_resize(0, sizeof(f_number_unsigneds_t), (void **) &setting->map_replacess.array, &setting->map_replacess.used, &setting->map_replacess.size, &f_number_unsignedss_delete_callback);
    f_memory_arrays_resize(0, sizeof(f_number_unsigneds_t), (void **) &setting->map_wrapss.array, &setting->map_wrapss.used, &setting->map_wrapss.size, &f_number_unsignedss_delete_callback);
  }
#endif // _di_iki_read_setting_delete_

#ifdef __cplusplus
} // extern "C"
#endif
