/**
 * FLL - Level 3
 *
 * Project: IKI Read
 * API Version: 0.7
 * Licenses: lgpl-2.1-or-later
 *
 * Provides the identify functionality.
 *
 * This is auto-included and should not need to be explicitly included.
 */
#ifndef _iki_read_identify_h
#define _iki_read_identify_h

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Process the arguments, associating the last matching reassignment or substitution with a given vocabulary name and value (Object and Content).
 *
 * This function expects appropriate sanity checks are performed on the reassignments or substitutions array before calling.
 *
 * @param main
 *   The program and settings data.
 * @param name
 *   A range within setting->buffer representing the name (Object) to match.
 * @param value
 *   A range within setting->buffer representing the value (Content) to match.
 * @param triple
 *   The setting, such as setting->substitute, to update.
 *
 * @return
 *   The matched substitution.
 *   The value of the triple.used is returned on no match.
 */
#ifndef _di_iki_read_identify_substitution_
  extern f_number_unsigned_t iki_read_identify_substitution(iki_read_main_t * const main, const f_range_t name, const f_range_t value, f_string_triples_t * const triple);
#endif // _di_iki_read_identify_substitution_

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _iki_read_identify_h
