#include "../iki_read.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_iki_read_print_data_line_
  void iki_read_print_data_line(fl_print_t * const print) {

    if (!print || !print->custom) return;

    iki_read_main_t * const main = (iki_read_main_t *) print->custom;

    if (F_status_is_error(main->setting.state.status)) return;

    if (!main->cache.expand.used) {
      main->setting.state.status = F_data_not;

      return;
    }

    f_number_unsigned_t i = 0;
    f_range_t range = macro_f_range_t_initialize_2(main->cache.expand.used);

    for (f_number_unsigned_t first = 0; range.start <= range.stop && range.start < main->cache.expand.used; ) {

      if (iki_read_signal_check(main)) return;

      main->setting.state.status = f_string_dynamic_seek_line(main->cache.expand, &range);
      if (F_status_is_error(main->setting.state.status)) return;

      if (main->setting.state.status == F_okay) {
        if (i == main->setting.line) {
          range.stop = range.start;
          range.start = first;

          f_print_dynamic_partial(main->cache.expand, range, print->to);

          break;
        }
        else {
          first = ++range.start;
          ++i;
        }
      }
      else {
        if (i == main->setting.line) {
          range.stop = range.start;
          range.start = first;

          f_print_dynamic_partial(main->cache.expand, range, print->to);
          f_print_dynamic(f_string_eol_s, print->to);
        }

        break;
      }
    } // for

    main->setting.state.status = F_okay;
  }
#endif // _di_iki_read_print_data_line_

#ifndef _di_iki_read_print_data_line_total_expand_
  void iki_read_print_data_total_expand(fl_print_t * const print) {

    if (!print || !print->custom) return;

    iki_read_main_t * const main = (iki_read_main_t *) print->custom;

    if (F_status_is_error(main->setting.state.status)) return;

    f_number_unsigned_t total = 0;

    {
      f_range_t range = macro_f_range_t_initialize_2(main->cache.expand.used);

      for (; range.start <= range.stop && range.start < main->cache.expand.used; ++total, ++range.start) {

        if (iki_read_signal_check(main)) return;

        main->setting.state.status = f_string_dynamic_seek_line(main->cache.expand, &range);
        if (F_status_is_error(main->setting.state.status)) return;
      } // for
    }

    iki_read_print_data_total(
      print,
      (main->setting.flag & iki_read_main_flag_line_d)
        ? main->setting.line < total ? 1 : 0
        : total
    );

    main->setting.state.status = (main->setting.flag & iki_read_main_flag_line_d)
      ? main->setting.line < total ? F_okay : F_data_not
      : total ? F_okay : F_data_not;
  }
#endif // _di_iki_read_print_data_line_total_expand_

#ifndef _di_iki_read_print_data_total_
  void iki_read_print_data_total(fl_print_t * const print, const f_number_unsigned_t total) {

    if (!print) return;

    fll_print_format("%ul%r", print->to, total, f_string_eol_s);
  }
#endif // _di_iki_read_print_data_total_

#ifndef _di_iki_read_print_data_wrap_append_
  void iki_read_print_data_wrap_append(fl_print_t * const print, const f_number_unsigned_t index) {

    if (!print || !print->custom) return;

    iki_read_main_t * const main = (iki_read_main_t *) print->custom;

    if (index >= main->setting.map_wrapss.used) return;

    f_number_unsigned_t * const array = main->setting.map_wrapss.array[index].array;

    for (f_number_unsigned_t i = 0; i < main->setting.map_wrapss.array[index].used; ++i) {

      if (array[i] < main->setting.wrap.used && main->setting.wrap.array[array[i]].c.used) {
        f_print_dynamic(main->setting.wrap.array[array[i]].c, print->to);
      }
    } // for
  }
#endif // _di_iki_read_print_data_wrap_append_

#ifndef _di_iki_read_print_data_wrap_prepend_
  void iki_read_print_data_wrap_prepend(fl_print_t * const print, const f_number_unsigned_t index) {

    if (!print || !print->custom) return;

    iki_read_main_t * const main = (iki_read_main_t *) print->custom;

    if (index >= main->setting.map_wrapss.used) return;

    f_number_unsigned_t * const array = main->setting.map_wrapss.array[index].array;

    for (f_number_unsigned_t i = 0; i < main->setting.map_wrapss.array[index].used; ++i) {

      if (array[i] < main->setting.wrap.used && main->setting.wrap.array[array[i]].b.used) {
        f_print_dynamic(main->setting.wrap.array[array[i]].b, print->to);
      }
    } // for
  }
#endif // _di_iki_read_print_data_wrap_prepend_

#ifdef __cplusplus
} // extern "C"
#endif
