#include "../iki_read.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_iki_read_print_message_help_
  void iki_read_print_message_help(fl_print_t * const print) {

    if (!print) return;

    fll_program_print_help_option_standard(print);

    f_print_dynamic_raw(f_string_eol_s, print->to);

    fll_program_print_help_option(print, iki_read_short_at_s, iki_read_long_at_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "    Select Variable at this numeric index.");
    fll_program_print_help_option(print, iki_read_short_name_s, iki_read_long_name_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "  Select Variables with this name.");
    fll_program_print_help_option(print, iki_read_short_select_s, iki_read_long_select_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "Select Vocabulay (aka: Object) at this index.");

    f_print_dynamic_raw(f_string_eol_s, print->to);

    fll_program_print_help_option(print, iki_read_short_content_s, iki_read_long_content_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "Print the Content (default)");
    fll_program_print_help_option(print, iki_read_short_line_s, iki_read_long_line_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "   Print only the given line of the output.");
    fll_program_print_help_option(print, iki_read_short_literal_s, iki_read_long_literal_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "Print the entire Variable (Vocabulary, Content, and syntax).");
    fll_program_print_help_option(print, iki_read_short_object_s, iki_read_long_object_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, " Print the Vocabulary (aka: Object).");
    fll_program_print_help_option(print, iki_read_short_total_s, iki_read_long_total_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "  Print the total number of Variables.");
    fll_program_print_help_option(print, iki_read_short_whole_s, iki_read_long_whole_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "  Print all of the data instead of just the IKI Variable data.");

    f_print_dynamic_raw(f_string_eol_s, print->to);

    fll_program_print_help_option(print, iki_read_short_reassign_s, iki_read_long_reassign_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "  Re-assign the Content with the given string for the Variable with the given Vocabulary name and matching Content.");
    fll_program_print_help_option(print, iki_read_short_replace_s, iki_read_long_replace_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "   Simple substitution, replacing the Content with the given string for the Variable with the given Vocabulary name.");
    fll_program_print_help_option(print, iki_read_short_substitute_s, iki_read_long_substitute_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "Substitute the Content with the given string for the Variable with the given Vocabulary name and matching Content value.");
    fll_program_print_help_option(print, iki_read_short_wrap_s, iki_read_long_wrap_s, f_console_symbol_short_normal_s, f_console_symbol_long_normal_s, "      Prepend and append strings with the given Vocabulary name.");

    f_print_dynamic_raw(f_string_eol_s, print->to);

    fll_program_print_help_usage(print, iki_read_program_name_s, fll_program_parameter_filenames_s);
  }
#endif // _di_iki_read_print_message_help_

#ifndef _di_iki_read_print_message_help_note_
  void iki_read_print_message_help_note(fl_print_t * const print) {

    if (!print) return;

    fl_print_format("%r %[Notes:%]%r", print->to, f_string_eol_s, print->set->important, print->set->important, f_string_eol_s);
    fl_print_format("  This program will find and print Variables, Vocabularies, or Content following the IKI standard, without focusing on any particular Vocabulary specification.%r%r", print->to, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The %[%r%r%] option requires 2 additional parameters:", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_replace_s, print->set->notable);
    fl_print_format(" %[<%]%r%[>%]", print->to, print->set->notable, print->set->notable, iki_read_substitution_vocabulary_s, print->set->notable, print->set->notable);
    fl_print_format(" %[<%]%r%[>%].%r", print->to, print->set->notable, print->set->notable, iki_read_substitution_with_s, print->set->notable, print->set->notable, f_string_eol_s);

    fl_print_format("    %[%r%]: The name of the Vocabulary whose content is to be substituted.%r", print->to, print->set->notable, iki_read_substitution_vocabulary_s, print->set->notable, f_string_eol_s);
    fl_print_format("    %[%r%]: The new string to use as the substitute.%r%r", print->to, print->set->notable, iki_read_substitution_with_s, print->set->notable, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The Vocabulary is case-sensitive and must exactly match.%r%r", print->to, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The %[%r%r%] and the", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_reassign_s, print->set->notable);
    fl_print_format(" %[%r%r%] options require 3 additional parameters:", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_substitute_s, print->set->notable);
    fl_print_format(" %[<%]%r%[>%]", print->to, print->set->notable, print->set->notable, iki_read_substitution_vocabulary_s, print->set->notable, print->set->notable);
    fl_print_format(" %[<%]%r%[>%]", print->to, print->set->notable, print->set->notable, iki_read_substitution_replace_s, print->set->notable, print->set->notable);
    fl_print_format(" %[<%]%r%[>%].%r", print->to, print->set->notable, print->set->notable, iki_read_substitution_with_s, print->set->notable, print->set->notable, f_string_eol_s);

    fl_print_format("    %[%r%]: The name of the Vocabulary whose content is to be substituted or re-assigned.%r", print->to, print->set->notable, iki_read_substitution_vocabulary_s, print->set->notable, f_string_eol_s);
    fl_print_format("    %[%r%]: The Content matching this exact string will be substituted or re-assigned.%r", print->to, print->set->notable, iki_read_substitution_replace_s, print->set->notable, f_string_eol_s);
    fl_print_format("    %[%r%]: The new string to use as the substitute or re-assignment.%r%r", print->to, print->set->notable, iki_read_substitution_with_s, print->set->notable, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The Vocabulary and replacement are case-sensitive and must exactly match.%r%r", print->to, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The %[%r%r%] option requires 3 additional parameters:", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_wrap_s, print->set->notable);
    fl_print_format(" %[<%]%r%[>%]", print->to, print->set->notable, print->set->notable, iki_read_substitution_vocabulary_s, print->set->notable, print->set->notable);
    fl_print_format(" %[<%]%r%[>%]", print->to, print->set->notable, print->set->notable, iki_read_substitution_before_s, print->set->notable, print->set->notable);
    fl_print_format(" %[<%]%r%[>%].%r", print->to, print->set->notable, print->set->notable, iki_read_substitution_after_s, print->set->notable, print->set->notable, f_string_eol_s);

    fl_print_format("    %[%r%]: The name of the Vocabulary whose content is to be wrapped.%r", print->to, print->set->notable, iki_read_substitution_vocabulary_s, print->set->notable, f_string_eol_s);
    fl_print_format("    %[%r%]: The string to prepend.%r", print->to, print->set->notable, iki_read_substitution_before_s, print->set->notable, f_string_eol_s);
    fl_print_format("    %[%r%]: The string to append.%r%r", print->to, print->set->notable, iki_read_substitution_after_s, print->set->notable, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The Vocabulary is case-sensitive and must exactly match.%r%r", print->to, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The difference between %[%r%r%]", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_replace_s, print->set->notable);
    fl_print_format(" and %[%r%r%] is that the", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_substitute_s, print->set->notable);
    fl_print_format(" %[%r%r%] option substitutes all matching Vocabulary names and the", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_replace_s, print->set->notable);
    fl_print_format(" %[%r%r%] option substitutes all matching Vocabulary names that must also have the given matching Content.%r%r", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_substitute_s, print->set->notable, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The %[%r%r%]", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_reassign_s, print->set->notable);
    fl_print_format(" option is identical to the %[%r%r%] option", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_substitute_s, print->set->notable);
    fl_print_format(" except that the %[%r%r%] option is ignored (not applied).%r%r", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_wrap_s, print->set->notable, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The %[%r%r%]", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_substitute_s, print->set->notable);
    fl_print_format(" option takes priority over the %[%r%r%] option when matching the same Variable.%r%r", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_replace_s, print->set->notable, f_string_eol_s, f_string_eol_s);

    fl_print_format("  Using both %[%r%r%]", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_total_s, print->set->notable);
    fl_print_format(" and %[%r%r%]", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_whole_s, print->set->notable);
    fl_print_format(" will result in a total representing the number of lines rather than number of Variables.%r", print->to, f_string_eol_s);

    fl_print_format("  Using all three of %[%r%r%]", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_total_s, print->set->notable);
    fl_print_format(", %[%r%r%]", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_whole_s, print->set->notable);
    fl_print_format(", and %[%r%r%]", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_line_s, print->set->notable);
    fl_print_format(" will result in a total number of Variables at the given line in the whole file.%r", print->to, f_string_eol_s);

    fl_print_format("  Using %[%r%r%]", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_total_s, print->set->notable);
    fl_print_format(" with %[%r%r%]", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_name_s, print->set->notable);
    fl_print_format(" will result in a total number of Variables matching the Vocabulary name.%r%r", print->to, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The %[%r%r%] parameter", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_name_s, print->set->notable);
    fl_print_format(" has precedence over the %[%r%r%] parameter.%r%r", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_at_s, print->set->notable, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The %[%r%r%] parameter", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_at_s, print->set->notable);
    fl_print_format(" has precedence over the %[%r%r%] parameter.%r%r", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_line_s, print->set->notable, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The %[%r%r%] parameter", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_line_s, print->set->notable);
    fl_print_format(" has precedence over the %[%r%r%] parameter.%r%r", print->to, print->set->notable, f_console_symbol_long_normal_s, iki_read_long_select_s, print->set->notable, f_string_eol_s, f_string_eol_s);

    fl_print_format("  The default behavior is to only display Content portion of the IKI Variable.%r", print->to, f_string_eol_s);
  }
#endif // _di_iki_read_print_message_help_note_

#ifdef __cplusplus
} // extern "C"
#endif
